using System;
using System.Collections;
using System.Data;
using Seasar.Extension.ADO;
using Seasar.Framework.Exceptions;

namespace Seasar.Dao.Impl
{
    /// <summary>
    /// XgAhvV[WpDynamicComandNX
    /// </summary>
    public class ProcedureDynamicCommand : AbstractDynamicCommand
    {
        /// <summary>
        /// ߂l^Cv
        /// </summary>
        private Type _returnType;

        /// <summary>
        /// p[^̓o͕
        /// </summary>
        private ParameterDirection[] argDirections = new ParameterDirection[0];

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="dataSource">f[^\[X</param>
        /// <param name="commandFactory">Commandt@Ng</param>
        public ProcedureDynamicCommand(IDataSource dataSource,
                                       ICommandFactory commandFactory) : base(dataSource, commandFactory)
        {
            ;
        }

        /// <summary>
        /// ߂l^Cv
        /// </summary>
        public Type ReturnType
        {
            get { return _returnType; }
            set { _returnType = value; }
        }

        /// <summary>
        /// p[^̓o͕
        /// </summary>
        public ParameterDirection[] ArgDirections
        {
            get { return argDirections; }
            set { argDirections = value; }
        }

        /// <summary>
        /// s
        /// </summary>
        /// <param name="args"></param>
        /// <returns></returns>
        public override object Execute(object[] args)
        {
            ICommandContext ctx = Apply(args);

            if ( DataSource == null ) throw new EmptyRuntimeException("dataSource");

            if ( _returnType != typeof (Hashtable) )
            {
                ObjectBasicProcedureHandler handler = new ObjectBasicProcedureHandler(DataSource, ctx.Sql);
                handler.ArgumentNames = ArgNames;
                handler.ArgumentTypes = ArgTypes;
                handler.ArgumentDirection = ArgDirections;

                return ( handler.Execute(args, _returnType) );
            }
            else
            {
                HashtableBasicProcedureHandler handler = new HashtableBasicProcedureHandler(DataSource, ctx.Sql);
                handler.ArgumentNames = ArgNames;
                handler.ArgumentTypes = ArgTypes;
                handler.ArgumentDirection = ArgDirections;

                return ( handler.Execute(args) );
            }
        }
    }
}